import rb, rhythmdb
import os
import pwd

class LogitechG15Plugin(rb.Plugin):
	def __init__(self):
		rb.Plugin.__init__(self)
	def activate(self, shell):
		try:
			# Open the LCD Fifo
			username = pwd.getpwuid(os.getuid())[0]
			self.fifo_filename = os.environ.get('HOME') + '/.g15fifo-' + username
			self.encoding = 'latin-1'
			self.LCDFifo = os.open(self.fifo_filename, os.O_WRONLY)
			if not(self.LCDFifo):
				print "Failed to open FIFO '%s'" % self.fifo_filename
				return
			# Display that the plugin was initialized
			msg = u'TM "Rhythmbox Logitech G15 Plugin"\n'
			os.write(self.LCDFifo, msg.encode(self.encoding))

			# register the playing-song-changed method
			self.shell = shell
			self.player = shell.get_player()
			self.pec_id = self.player.connect('playing-song-changed', self.playing_entry_changed)
			self.playing_entry_changed(self.player, self.player.get_playing_entry())
			# Finish
			print "G15 was initialized successfully"
		except Exception, err:
			print "Sorry, something failed"

	def deactivate(self, shell):
		del self.shell
		if(self.LCDFifo):
			os.close(self.LCDFifo)

	def playing_entry_changed(self, player, entry):
		try:
			self.clear_LCD()
			msg = self.get_title()
			if entry is not None:
				db = self.shell.get_property("db")
				artist = db.entry_get(entry, rhythmdb.PROP_ARTIST)
				album = db.entry_get(entry, rhythmdb.PROP_ALBUM)
				title = db.entry_get(entry, rhythmdb.PROP_TITLE)
				genre = db.entry_get(entry, rhythmdb.PROP_GENRE)
				rating = db.entry_get(entry, rhythmdb.PROP_RATING)
				duration = 10 #db.entry_get(entry, rhythmdb.PROP_DURATION)
				time_playing = 11 #self.player.get_playing_time()
				msg = msg + u' "Artist: %s" "Album:  %s" "Title:  %s" "Genre:  %s" "Rating: %d" "%d" "%d"\n' % (artist, album, title, genre, rating, duration, time_playing)
			else:
				msg = msg + u' "*Paused*"\n'
			os.write(self.LCDFifo, msg.encode(self.encoding))
		except Exception, err:
			print "Failed to update LCD on changed entry: %s" % err 

	def clear_LCD(self):
		os.write(self.LCDFifo, "PC 0\n")

	def get_title(self):
		return 'TS "          == Rhythmbox ==" '
